option(USE_BOOST_FILESYSTEM "Compiles and links against boost::filesystem instead of std::filesystem [default: OFF]." OFF)

if(${USE_BOOST_FILESYSTEM} OR APPLE)
    include(FindBoost)
    find_package(Boost 1.6 REQUIRED COMPONENTS filesystem)
    include_directories(${Boost_INCLUDE_DIRS})
    set(USING_BOOST_FILESYSTEM TRUE PARENT_SCOPE)
    set(USING_BOOST_FILESYSTEM TRUE)
    set(FILESYSTEM_LIBS "Boost::filesystem")
    message(STATUS "[FilesystemResolver]: Using boost::filesystem API")
else()
    set(USING_BOOST_FILESYSTEM FALSE PARENT_SCOPE)
    set(USING_BOOST_FILESYSTEM FALSE)
    message(STATUS "[FilesystemResolver]: Using standard C++ filesystem API")
    if(APPLE OR "${CMAKE_SYSTEM}" MATCHES "Linux")
        set(FILESYSTEM_LIBS "stdc++fs")
    else()
        set(FILESYSTEM_LIBS)
    endif()
endif()

